#ifndef _FORWARD_SEQUENCE_ARCHETYPE_
#define _FORWARD_SEQUENCE_ARCHETYPE_

// MS compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
# pragma once
#endif

#pragma message("forward_sequence_archetype.hpp")

#define FORWARD_SEQUENCE_ARCHTYPE(archetype)                      \
                                                                  \
namespace boost {                                                 \
namespace mpl {                                                   \
                                                                  \
template<>                                                        \
struct begin<archetype> {                                         \
    typedef forward_iterator_archetype type;                      \
};                                                                \
template<>                                                        \
struct end<archetype> {                                           \
    typedef forward_iterator_archetype type;                      \
};                                                                \
template<>                                                        \
struct size<archetype> {                                          \
    typedef integral_constant_archetype<unsigned int, 0> type;    \
};                                                                \
template<>                                                        \
struct empty<archetype> {                                         \
    typedef boolean_integral_constant_archetype<true> type;       \
};                                                                \
template<>                                                        \
struct front<archetype> {                                         \
    typedef int type;                                             \
};                                                                \
                                                                  \
}                                                                 \
}
/**/
#endif // _FORWARD_SEQUENCE_ARCHETYPE_
